UNIT UTST_cl_DAO;
{$mode ObjFPC}{$H+}
INTERFACE
USES
    Classes
  , Sysutils
  , Controls
  , db
  , ZConnection
  , ZDataSet
  , Dialogs
  ;





TYPE
  TCL_DAO = CLASS( TObject )
    PRIVATE { Attribute }

    PRIVATE { Objecte }
      mo_DataSource     : TDataSource;
      mo_DataSet        : TDataSet;

    PRIVATE { Event-Handler }
      fon_Data_Change   : TDataChangeEvent;

    PRIVATE { SET'ter}
      PROCEDURE   SET_EVT_On_DataChange( io_Evt : TDataChangeEvent );

    PRIVATE { GET'ter}

    PRIVATE { Property's }
    PROTECTED { Functions }

    PROTECTED { Procedures }

    PROTECTED { Event-Handler }
      PROCEDURE   EVTHDL_On_Data_Change( Sender : Tobject; Field: Tfield );

    PROTECTED { Property's }
    PUBLIC
      CONSTRUCTOR Create( io_DSrc : TDataSource; io_DSet : TDataSet );
      DESTRUCTOR  Destroy;                                                                          OVERRIDE;

    PUBLIC { Functions }


    PUBLIC { Procedures }
      PROCEDURE   Open;
      PROCEDURE   Close;

    PUBLIC { Event-Handler }
    PUBLIC { Property's }
      PROPERTY    ON_Data_Change : TDataChangeEvent
                  READ  fon_Data_Change
                  WRITE SET_EVT_On_DataChange;

      PROPERTY    DataSource : TDataSource
                  READ  mo_DataSource;

  END;



IMPLEMENTATION




{===================================================================================================
===================================================================================================}
CONSTRUCTOR TCL_DAO.Create( io_DSrc : TDataSource; io_DSet : TDataSet );
VAR lv_s : String;
BEGIN
  INHERITED Create;
  mo_DataSource := io_DSrc;
  mo_DataSet    := io_DSet;

{===================================================================================================
Das eigenen Property für einen Externen aufruf ( Aufruf Kette )
===================================================================================================}
  fon_Data_Change := NIL;

{===================================================================================================
 Diese Call Back Methode funzt einwandfrei
 Sobald die Tabelle geöffnet wird, wird diese methode ausgeführt
===================================================================================================}
  io_DSrc.OnDataChange  := @EVTHDL_On_Data_Change;
END;


{===================================================================================================
===================================================================================================}
DESTRUCTOR TCL_DAO.Destroy;
BEGIN
  INHERITED Destroy;
END;

{===================================================================================================
Versuch um festzustellen wann dieses Property auf NIL gesetzt wird.
Resultat: "Leider nicht feststellbar"
===================================================================================================}
PROCEDURE TCL_DAO.SET_EVT_On_DataChange( io_Evt : TDataChangeEvent );
BEGIN
  fon_Data_Change := io_Evt;
END;


{###################################################################################################
####################################################################################################
                                       EVENT - Handler
####################################################################################################
###################################################################################################}




{===================================================================================================
Dieser Klassen eigene Handler wird wie gewünscht ausgeführt
===================================================================================================}
PROCEDURE TCL_DAO.EVTHDL_On_Data_Change( Sender: Tobject; Field: Tfield );
BEGIN
  IF DataSource.State <> dsBrowse THEN BEGIN
    EXIT;
  END;

  Showmessage( 'TCL_DAO.EVTHDL_On_Data_Change  Hier ist alles OK' );

{===================================================================================================
In diesem Testprogramm ist das Property gesetzt durch "@EVTHDL_On_DataChange" und funzt ebenfalls.
In meinem "riesigen Original Programm" ist dieses Property jedoch IMMER Nil, obwohl es Definitiv
gesetzt wurde.

Ich mochte nun wiessen von wem und wann genau dieses Property wieder gelöscht wird
===================================================================================================}
  IF Assigned( ON_Data_Change ) THEN
    ON_Data_Change( Self, Field );
END;



{===================================================================================================
===================================================================================================}
PROCEDURE TCL_DAO.Open;
BEGIN
  mo_DataSet.Open;
END;


{===================================================================================================
===================================================================================================}
PROCEDURE TCL_DAO.Close;
BEGIN
  mo_DataSet.Close;
END;



END.

